// CodeVisionAVR C Compiler
// (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATtiny13


#pragma used+
#pragma used+
sfrb ADCSRB=0x03;
sfrb ADCL=0x04;
sfrb ADCH=0x05;
sfrw ADCW=0x04; // 16 bit access
sfrb ADCSRA=0x06;
sfrb ADMUX=0x07;
sfrb ACSR=0x08;
sfrb DIDR0=0x14;
sfrb PCMSK=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEAR=0x1e;
sfrb WDTCR=0x21;
sfrb CLKPR=0x26;
sfrb GTCCR=0x28;
sfrb OCR0B=0x29;
sfrb DWDR=0x2e;
sfrb TCCR0A=0x2f;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0B=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb OCR0A=0x36;
sfrb SPMCSR=0x37;
sfrb TIFR0=0x38;
sfrb TIMSK0=0x39;
sfrb GIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb SPL=0x3d;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x18
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-





char gysteresys_min=0;//   
char gysteresys_max=0;//     

eeprom char light_level=240;   

char adc_data; 

bit mode_flag=0;//   1-> ; 0->     

bit changes_enable=0 ;//   ( = TRUE ->     )

interrupt [10] void adc_isr(void)
{
    adc_data=ADCH;
    if(changes_enable==1 )
    {    
        changes_enable=0 ;
        if(mode_flag==0)// 
            {        
                if(adc_data<=10)OCR0A=0;
                else if(adc_data>=245)OCR0A=255;
                else if(adc_data>gysteresys_max)OCR0A=255;
                else if(adc_data<gysteresys_min)OCR0A=0;
            }
        else // 
            {    

                 if(adc_data>gysteresys_max&&OCR0A<255)OCR0A++;
                 else if(adc_data<gysteresys_min&&OCR0A>0)OCR0A--;
            }
    }

}


void main(void)
{
int i=0;
 
// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#pragma optsize+

// Input/Output Ports initialization
// Port B initialization
// Func5=In Func4=In Func3=In Func2=In Func1=In Func0=Out 
// State5=T State4=T State3=T State2=T State1=T State0=0 
PORTB=0b00010100;
DDRB=0b00000001;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 37,500 kHz
// Mode: Fast PWM top=FFh
// OC0A output: Inverted PWM
// OC0B output: Disconnected
TCCR0A=0xC3;
TCCR0B=0x03;
TCNT0=0x00;
OCR0A=0xFF;
OCR0B=0x00;
 
// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-5: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
ACSR=0x80;
ADCSRB=0x00;

// ADC initialization
// ADC Clock frequency: 150,000 kHz
// ADC Bandgap Voltage Reference: Off
// ADC Auto Trigger Source: None
// Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
DIDR0&=0x03;
DIDR0|=0x00;
ADMUX=0b00100011;
ADCSRA=0xEE;

if(light_level>=245)gysteresys_max=255;
else gysteresys_max=light_level+10;
if(light_level<=10)gysteresys_min=0;
else gysteresys_min=light_level-10;
// Global enable interrupts
#asm("sei")



while (1)
      {     
            for(i=0;i<7000;i++)// 7.  ,    
            {
                if(PINB.4 ==1)
                {
                    mode_flag=0;
                } 
                else  mode_flag=1;//  
           
                if(PINB.2 ==0)
                {
                    #asm("cli")
                    if(adc_data<=15)adc_data=15;
                    light_level=adc_data;
                    if(light_level>=245)gysteresys_max=255;
                    else gysteresys_max=light_level+10;
                    if(light_level<=10)gysteresys_min=0;
                    else gysteresys_min=light_level-10;
                    delay_ms(2000);
                    #asm("sei")
                }
                delay_ms(1); 
           }  
           changes_enable=1 ;

      };
}
