#include <tiny13.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x18
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#include <delay.h>

#define mode PINB.4 //
#define set_light_level PINB.2 //

#define ON 0 //
#define OFF 1 //

#define FALSE 0 //
#define TRUE 1 //

char gysteresys_min=0;//   
char gysteresys_max=0;//   

eeprom char light_level=240;

char adc_data;

bit mode_flag=0;//   1-> ; 0-> 

bit changes_enable=FALSE;//   ( = TRUE ->     )

interrupt [ADC_INT] void adc_isr(void)
{
    adc_data=ADCH;
    if(changes_enable==TRUE)
    {
        changes_enable=FALSE;
        if(mode_flag==0)// 
            {
                if(adc_data<=10)OCR0A=0;
                else if(adc_data>=245)OCR0A=255;
                else if(adc_data>gysteresys_max)OCR0A=255;
                else if(adc_data<gysteresys_min)OCR0A=0;
            }
        else // 
            {

                 if(adc_data>gysteresys_max&&OCR0A<255)OCR0A++;
                 else if(adc_data<gysteresys_min&&OCR0A>0)OCR0A--;
            }
    }

}


void main(void)
{
int i=0;

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port B initialization
// Func5=In Func4=In Func3=In Func2=In Func1=In Func0=Out
// State5=T State4=T State3=T State2=T State1=T State0=0
PORTB=0b00010100;
DDRB=0b00000001;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 37,500 kHz
// Mode: Fast PWM top=FFh
// OC0A output: Inverted PWM
// OC0B output: Disconnected
TCCR0A=0xC3;
TCCR0B=0x03;
TCNT0=0x00;
OCR0A=0xFF;
OCR0B=0x00;

// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-5: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
ACSR=0x80;
ADCSRB=0x00;

// ADC initialization
// ADC Clock frequency: 150,000 kHz
// ADC Bandgap Voltage Reference: Off
// ADC Auto Trigger Source: None
// Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
DIDR0&=0x03;
DIDR0|=0x00;
ADMUX=0b00100011;
ADCSRA=0xEE;

if(light_level>=245)gysteresys_max=255;
else gysteresys_max=light_level+10;
if(light_level<=10)gysteresys_min=0;
else gysteresys_min=light_level-10;
// Global enable interrupts
#asm("sei")



while (1)
      {
            for(i=0;i<7000;i++)// 7.  ,    
            {
                if(mode==1)
                {
                    mode_flag=0;
                }
                else  mode_flag=1;//  

                if(set_light_level==0)
                {
                    #asm("cli")
                    if(adc_data<=15)adc_data=15;
                    light_level=adc_data;
                    if(light_level>=245)gysteresys_max=255;
                    else gysteresys_max=light_level+10;
                    if(light_level<=10)gysteresys_min=0;
                    else gysteresys_min=light_level-10;
                    delay_ms(2000);
                    #asm("sei")
                }
                delay_ms(1);
           }
           changes_enable=TRUE;

      };
}
